﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TXTextControl;
using TXTextControl.DocumentServer.Fields;
using System.Data.Common;
namespace tx_bound_fields
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // connect the controls
            textControl1.RulerBar = rulerBar2;
            textControl1.ButtonBar = buttonBar1;
            textControl1.StatusBar = statusBar1;
            textControl1.VerticalRulerBar = rulerBar1;
        }

        private DataSet ds_DataSet;
        private DataRow dr_CurrentRow;
        private string xmlDataSourcePath;

        private void btn_Browse_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return;

            xmlDataSourcePath = openFileDialog1.FileName;

            tb_XMLPath.Text = xmlDataSourcePath;

            // new DataSet that holds the address data
            ds_DataSet = new DataSet();
            ds_DataSet.ReadXml(xmlDataSourcePath);

            // set the DataGridView DataSource
            dataGridView1.DataSource = ds_DataSet;
            dataGridView1.DataMember = "address";
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // load the template document
            TXTextControl.LoadSettings ls = new TXTextControl.LoadSettings();
            ls.ApplicationFieldFormat = TXTextControl.ApplicationFieldFormat.MSWord;

            textControl1.Load(TXTextControl.StreamType.WordprocessingML, ls);

            foreach (ApplicationField field in textControl1.ApplicationFields)
            {
                field.ShowActivated = true;
            }

            if(ds_DataSet != null)
                UpdateFields();
        }

        private void UpdateFields()
        {
            // loop through all ApplicationFields and merge them with the
            // currently selected row data
            foreach (object obj in textControl1.TextParts)
            {
                foreach (ApplicationField field in ((IFormattedText)obj).ApplicationFields)
                {
                    if(field.TypeName != "MERGEFIELD")
                        continue;

                    MergeField mf = new MergeField(field);

                    if (dataGridView1.SelectedRows.Count == 0)
                        return;

                    dr_CurrentRow = ds_DataSet.Tables[0].Rows[dataGridView1.SelectedRows[0].Index];

                    foreach(DataColumn col in ds_DataSet.Tables[0].Columns)
                    {
                        if (col.ColumnName == mf.Name)
                            mf.Text = (string)dr_CurrentRow[col];
                    }
                }
            }

            // write the current DataSet back to the XML file
            ds_DataSet.WriteXml(xmlDataSourcePath);
            // display the XML file
            webBrowser1.Navigate(xmlDataSourcePath);
        }

        private void textControl1_TextFieldChanged(object sender, TextFieldEventArgs e)
        {
            if (ds_DataSet == null)
                return;

            if (e.TextField is TXTextControl.ApplicationField == false)
                return;

            // update the DataSet when the field's text has been changed
            // by the user

            ApplicationField field = e.TextField as TXTextControl.ApplicationField;
            MergeField mf = new MergeField(field);

            dr_CurrentRow[mf.Name] = mf.Text;

            UpdateFields();
        }

        private void dataGridView1_RowEnter(object sender, DataGridViewCellEventArgs e)
        {
            UpdateFields();
        }
    }
}
